Bug 12589 - CTDB statd-callout does not cause grace period when CTDB_NFS_CALLOUT=""
CTDB statd-callout does not cause grace period when CTDB_NFS_CALLOUT=""
Status: RESOLVED FIXED
Product: Samba 4.1 and newer
Classification: Unclassified
Component: CTDB
4.5.5
All All
: P5 normal
: ---
Assigned To: Karolin Seeger
Samba QA Contact
:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2017-02-16 04:14 UTC by Martin Schwenke
Modified: 2017-02-21 08:52 UTC (History)
1 user (show)

See Also:


Attachments
Patch for 4.5 and 4.6 (1.59 KB, patch)
2017-02-16 23:36 UTC, Martin Schwenke
amitay: review+
Details
Patch for 4.3 and 4.4 (1.68 KB, patch)
2017-02-16 23:38 UTC, Martin Schwenke
amitay: review+
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Martin Schwenke 2017-02-16 04:14:29 UTC
Some configurations may set CTDB_NFS_CALLOUT to the empty string.
They may do this if they allow a choice of NFS implementations.  In
this case the default call-out for Linux kernel NFS should be used.
However, statd-callout does not call nfs_callout_init() to set the
default.  Therefore, statd-callout is unable to restart the lock
manager, so the grace period is never entered.

statd-callout must call nfs_callout_init() before trying to restart
the lock manager.
Comment 1 Martin Schwenke 2017-02-16 23:36:32 UTC
Created attachment 12953 [details]
Patch for 4.5 and 4.6
Comment 2 Martin Schwenke 2017-02-16 23:38:00 UTC
Created attachment 12956 [details]
Patch for 4.3 and 4.4

4.3 and 4.4 require a different patch.  Those versions do not have a nfs_callout_init() function, so just inline setting of CTDB_NFS_CALLOUT.
Comment 3 Amitay Isaacs 2017-02-16 23:59:04 UTC
Hi Karolin,

This is ready for v4-3, v4-4, v4-5 and v4-6.
Comment 4 Martin Schwenke 2017-02-17 00:03:18 UTC
Oops, can't do 4.3, since it is in security-fix-only mode...  :-(

Sorry, I was trying to fix the bug all the way back to where it was introduced...  :-)
Comment 5 Karolin Seeger 2017-02-17 11:07:44 UTC
(In reply to Martin Schwenke from comment #4)
Pushed to autobuild-v4-{6,5,4}-test.
Comment 6 Karolin Seeger 2017-02-21 08:52:36 UTC
(In reply to Karolin Seeger from comment #5)
Pushed to all branches.
Closing out bug report.

Thanks!